## rehex 0.5.4

=== Makefile ===
# Reverse Engineer's Hex Editor
# Copyright (C) 2017-2022 Daniel Collins <solemnwarning@solemnwarning.net>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as published by
# the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

LUA          ?= lua
WX_CONFIG    ?= wx-config
CAPSTONE_PKG ?= capstone
JANSSON_PKG  ?= jansson
LUA_PKG      ?= $(shell pkg-config --exists lua5.3 && echo lua5.3 || echo lua)

EXE ?= rehex
EMBED_EXE ?= ./tools/embed
GTKCONFIG_EXE ?= ./tools/gtk-config
HELP_TARGET ?= help/rehex.htb

# Wrapper around the $(shell) function that aborts the build if the command
# exits with a nonzero status.
shell-or-die = $\
	$(eval sod_out := $$(shell $(1); echo $$$$?))$\
	$(if $(filter 0,$(lastword $(sod_out))),$\
		$(wordlist 1, $(shell echo $$(($(words $(sod_out)) - 1))), $(sod_out)),$\
		$(error $(1) exited with status $(lastword $(sod_out))))

# Check if we are building target(s) that don't need to compile anything and
# skip fetching compiler flags from wx-config/pkg-config/etc if so, this avoids
# having to have our dependencies on build hosts that are going to use a chroot
# or other container for doing the actual build.

NONCOMPILE_TARGETS=clean distclean dist

need_compiler_flags=1
ifneq ($(MAKECMDGOALS),)
	ifeq ($(filter-out $(NONCOMPILE_TARGETS),$(MAKECMDGOALS)),)
		need_compiler_flags=0
	endif
endif

ifeq ($(BUILD_HELP),)
	BUILD_HELP=1
endif

ifeq ($(BUILD_HELP),0)
	HELP_TARGET :=
else
	HELP_CFLAGS := -DBUILD_HELP
	HELP_LIBS := html
endif

ifeq ($(need_compiler_flags),1)
	WX_CXXFLAGS ?= $(call shell-or-die,$(WX_CONFIG) --cxxflags base core aui propgrid adv $(HELP_LIBS))
	WX_LIBS     ?= $(call shell-or-die,$(WX_CONFIG) --libs     base core aui propgrid adv $(HELP_LIBS))
	
	CAPSTONE_CFLAGS ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --cflags)
	CAPSTONE_LIBS   ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --libs)
	
	JANSSON_CFLAGS ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --cflags)
	JANSSON_LIBS   ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --libs)
	
	LUA_CFLAGS ?= $(call shell-or-die,pkg-config $(LUA_PKG) --cflags)
	LUA_LIBS   ?= $(call shell-or-die,pkg-config $(LUA_PKG) --libs)
	
	GTK_CFLAGS = $$($(GTKCONFIG_EXE) --cflags)
	GTK_LIBS   = $$($(GTKCONFIG_EXE) --libs)
endif

ifeq ($(DEBUG),)
	DEBUG=0
endif

ifeq ($(DEBUG),0)
	DEBUG_CFLAGS := -DNDEBUG
else
	DEBUG_CFLAGS := -ggdb
endif

ifeq ($(PROFILE),)
	PROFILE=0
endif

ifeq ($(PROFILE),0)
	PROFILE_CFLAGS :=
else
	PROFILE_CFLAGS := -DREHEX_PROFILE
endif

CFLAGS          := -Wall -std=c99   -I. -Iinclude/ -IwxLua/modules/ -DREHEX_CACHE_CHARACTER_BITMAPS $(DEBUG_CFLAGS) $(PROFILE_CFLAGS) $(HELP_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(CFLAGS)
CXXFLAGS_NO_GTK := -Wall -std=c++11 -I. -Iinclude/ -IwxLua/modules/ -DREHEX_CACHE_CHARACTER_BITMAPS $(DEBUG_CFLAGS) $(PROFILE_CFLAGS) $(HELP_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(CXXFLAGS)
CXXFLAGS        := -Wall -std=c++11 -I. -Iinclude/ -IwxLua/modules/ -DREHEX_CACHE_CHARACTER_BITMAPS $(DEBUG_CFLAGS) $(PROFILE_CFLAGS) $(HELP_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(GTK_CFLAGS) $(CXXFLAGS)

uname_S := $(shell uname -s 2>/dev/null)
ifeq ($(uname_S),FreeBSD)
	LDLIBS += -liconv
endif
ifeq ($(uname_S),OpenBSD)
	LDLIBS += -liconv
endif

LDLIBS := -lunistring $(WX_LIBS) $(GTK_LIBS) $(CAPSTONE_LIBS) $(JANSSON_LIBS) $(LUA_LIBS) $(LDLIBS)

# Define this for releases
VERSION := 0.5.4

ifdef VERSION
	LONG_VERSION := Version $(VERSION)
else
	# Check if we are actually in a git checkout before trying to get the
	# commit hash with `git log`, else we blow up in a git-archive export.
	
	ifneq ($(wildcard .git/*),)
		GIT_COMMIT_SHA ?= $(call shell-or-die,git log -1 --format="%H")
	else
		GIT_COMMIT_SHA ?= UNKNOWN
	endif
	
	GIT_COMMIT_TIME ?= $(call shell-or-die,git log -1 --format="%ct")
	
	VERSION      := cd847ccb965b8b6de478aaf98433f5c46bd1d27f
	LONG_VERSION := Snapshot cd847ccb965b8b6de478aaf98433f5c46bd1d27f
endif

DEPDIR := .d
DEPPRE = @mkdir -p "$(dir $(DEPDIR)/$@.Td)"
DEPFLAGS = -MT $@ -MMD -MP -MF $(DEPDIR)/$@.Td
DEPPOST = @mv -f $(DEPDIR)/$@.Td $(DEPDIR)/$@.d && touch $@

WXLUA_BINDINGS := wxLua/bindings/.done

.PHONY: all
all: $(EXE)

# Stop Make from deleting intermediate files at-will. Some intermediates (e.g. resources) are used
# by multiple targets (all and test) and so they should persist. Others are generated as a
# side-effect of another target (wxLua bindings) so Make cannot properly track how to build them
# when it needs to recreate them later.
.SECONDARY:

.PHONY: check
check: tests/all-tests
	./tests/all-tests
	
	for p in $(PLUGINS); \
	do \
		$(MAKE) -C plugins/$${p} LUA=$(LUA) check || exit $$?; \
	done

.PHONY: clean
clean:
	rm -f res/ascii16.c   res/ascii16.h \
	      res/ascii24.c   res/ascii24.h \
	      res/ascii32.c   res/ascii32.h \
	      res/ascii48.c   res/ascii48.h \
	      res/diff_fold16.c res/diff_fold16.h \
	      res/diff_fold24.c res/diff_fold24.h \
	      res/diff_fold32.c res/diff_fold32.h \
	      res/diff_fold48.c res/diff_fold48.h \
	      res/icon16.c    res/icon16.h \
	      res/icon32.c    res/icon32.h \
	      res/icon48.c    res/icon48.h \
	      res/icon64.c    res/icon64.h \
	      res/icon128.c   res/icon128.h \
	      res/license.c   res/license.h   res/license.done \
	      res/offsets16.c res/offsets16.h \
	      res/offsets24.c res/offsets24.h \
	      res/offsets32.c res/offsets32.h \
	      res/offsets48.c res/offsets48.h \
	      res/spinner24.c   res/spinner24.h
	
	rm -f $(APP_OBJS)
	rm -f $(EXE)
	rm -f $(TEST_OBJS)
	rm -f ./tests/all-tests
	rm -f $(EMBED_EXE)
	rm -f $(GTKCONFIG_EXE)
	
	grep -r "generated by genwxbind.lua" wxLua/ --exclude=genwxbind.lua | cut -d: -f1 | sort | uniq | xargs -r rm
	rm -f $(WXLUA_BINDINGS)
	
	rm -f src/lua-bindings/rehex_bind.done src/lua-bindings/rehex_bind.cpp src/lua-bindings/rehex_bind.h
	rm -f src/lua-plugin-preload.done src/lua-plugin-preload.c src/lua-plugin-preload.h

.PHONY: distclean
distclean: clean

WXLUA_OBJS := \
	wxLua/modules/wxlua/bit.o \
	wxLua/modules/wxlua/lbitlib.o \
	wxLua/modules/wxlua/wxlbind.o \
	wxLua/modules/wxlua/wxlcallb.o \
	wxLua/modules/wxlua/wxllua.o \
	wxLua/modules/wxlua/wxlobject.o \
	wxLua/modules/wxlua/wxlstate.o \
	wxLua/modules/wxlua/wxlua_bind.o

WXBIND_OBJS := \
	wxLua/modules/wxbind/src/wxadv_bind.o \
	wxLua/modules/wxbind/src/wxadv_wxladv.o \
	wxLua/modules/wxbind/src/wxaui_bind.o \
	wxLua/modules/wxbind/src/wxbase_base.o \
	wxLua/modules/wxbind/src/wxbase_bind.o \
	wxLua/modules/wxbind/src/wxbase_config.o \
	wxLua/modules/wxbind/src/wxbase_data.o \
	wxLua/modules/wxbind/src/wxbase_datetime.o \
	wxLua/modules/wxbind/src/wxbase_file.o \
	wxLua/modules/wxbind/src/wxcore_appframe.o \
	wxLua/modules/wxbind/src/wxcore_bind.o \
	wxLua/modules/wxbind/src/wxcore_clipdrag.o \
	wxLua/modules/wxbind/src/wxcore_controls.o \
	wxLua/modules/wxbind/src/wxcore_core.o \
	wxLua/modules/wxbind/src/wxcore_defsutils.o \
	wxLua/modules/wxbind/src/wxcore_dialogs.o \
	wxLua/modules/wxbind/src/wxcore_event.o \
	wxLua/modules/wxbind/src/wxcore_gdi.o \
	wxLua/modules/wxbind/src/wxcore_geometry.o \
	wxLua/modules/wxbind/src/wxcore_graphics.o \
	wxLua/modules/wxbind/src/wxcore_help.o \
	wxLua/modules/wxbind/src/wxcore_image.o \
	wxLua/modules/wxbind/src/wxcore_mdi.o \
	wxLua/modules/wxbind/src/wxcore_menutool.o \
	wxLua/modules/wxbind/src/wxcore_picker.o \
	wxLua/modules/wxbind/src/wxcore_print.o \
	wxLua/modules/wxbind/src/wxcore_sizer.o \
	wxLua/modules/wxbind/src/wxcore_windows.o \
	wxLua/modules/wxbind/src/wxcore_wxlcore.o \
	wxLua/modules/wxbind/src/wxpropgrid_bind.o

APP_OBJS := \
	res/actual_size16.o \
	res/ascii16.o \
	res/ascii24.o \
	res/ascii32.o \
	res/ascii48.o \
	res/diff_fold16.o \
	res/diff_fold24.o \
	res/diff_fold32.o \
	res/diff_fold48.o \
	res/fit_to_screen16.o \
	res/icon16.o \
	res/icon32.o \
	res/icon48.o \
	res/icon64.o \
	res/icon128.o \
	res/license.o \
	res/offsets16.o \
	res/offsets24.o \
	res/offsets32.o \
	res/offsets48.o \
	res/spinner24.o \
	res/swap_horiz16.o \
	res/swap_vert16.o \
	res/zoom_in16.o \
	res/zoom_out16.o \
	src/AboutDialog.o \
	src/AppMain.o \
	src/AppSettings.o \
	src/AppTestable.o \
	src/ArtProvider.o \
	src/BasicDataTypes.o \
	src/BitmapTool.o \
	src/buffer.o \
	src/BytesPerLineDialog.o \
	src/ByteRangeSet.o \
	src/CharacterEncoder.o \
	src/CharacterFinder.o \
	src/ClickText.o \
	src/CodeCtrl.o \
	src/CommentTree.o \
	src/ConsoleBuffer.o \
	src/ConsolePanel.o \
	src/DataType.o \
	src/decodepanel.o \
	src/DiffWindow.o \
	src/disassemble.o \
	src/DisassemblyRegion.o \
	src/document.o \
	src/DocumentCtrl.o \
	src/EditCommentDialog.o \
	src/Events.o \
	src/FillRangeDialog.o \
	src/IntelHexExport.o \
	src/IntelHexImport.o \
	src/LicenseDialog.o \
	src/lua-bindings/rehex_bind.o \
	src/lua-plugin-preload.o \
	src/LuaPluginLoader.o \
	src/mainwindow.o \
	src/Palette.o \
	src/profile.o \
	src/search.o \
	src/SelectRangeDialog.o \
	src/StringPanel.o \
	src/textentrydialog.o \
	src/Tab.o \
	src/ToolPanel.o \
	src/util.o \
	src/VirtualMappingDialog.o \
	src/VirtualMappingList.o \
	src/win32lib.o \
	$(WXLUA_OBJS) \
	$(WXBIND_OBJS) \
	$(EXTRA_APP_OBJS)

$(EXE): $(APP_OBJS) $(GTKCONFIG_EXE)
	$(CXX) $(CXXFLAGS) -DLONG_VERSION='"$(LONG_VERSION)"' -DLIBDIR='"$(libdir)"' -DDATADIR='"$(datadir)"' -c -o res/version.o res/version.cpp
	$(CXX) $(CXXFLAGS) -o $@ $(APP_OBJS) res/version.o $(LDFLAGS) $(LDLIBS)

TEST_OBJS := \
	googletest/src/gtest-all.o \
	res/actual_size16.o \
	res/ascii16.o \
	res/ascii24.o \
	res/ascii32.o \
	res/ascii48.o \
	res/diff_fold16.o \
	res/diff_fold24.o \
	res/diff_fold32.o \
	res/diff_fold48.o \
	res/fit_to_screen16.o \
	res/icon16.o \
	res/icon32.o \
	res/icon48.o \
	res/icon64.o \
	res/icon128.o \
	res/license.o \
	res/offsets16.o \
	res/offsets24.o \
	res/offsets32.o \
	res/offsets48.o \
	res/spinner24.o \
	res/swap_horiz16.o \
	res/swap_vert16.o \
	res/zoom_in16.o \
	res/zoom_out16.o \
	src/AboutDialog.o \
	src/AppSettings.o \
	src/AppTestable.o \
	src/ArtProvider.o \
	src/BasicDataTypes.o \
	src/BitmapTool.o \
	src/buffer.o \
	src/ByteRangeSet.o \
	src/BytesPerLineDialog.o \
	src/CharacterEncoder.o \
	src/CharacterFinder.o \
	src/ClickText.o \
	src/CommentTree.o \
	src/ConsoleBuffer.o \
	src/DataType.o \
	src/DiffWindow.o \
	src/DisassemblyRegion.o \
	src/document.o \
	src/DocumentCtrl.o \
	src/EditCommentDialog.o \
	src/Events.o \
	src/FillRangeDialog.o \
	src/IntelHexExport.o \
	src/IntelHexImport.o \
	src/LicenseDialog.o \
	src/lua-bindings/rehex_bind.o \
	src/lua-plugin-preload.o \
	src/LuaPluginLoader.o \
	src/mainwindow.o \
	src/Palette.o \
	src/search.o \
	src/SelectRangeDialog.o \
	src/StringPanel.o \
	src/Tab.o \
	src/textentrydialog.o \
	src/ToolPanel.o \
	src/util.o \
	src/VirtualMappingDialog.o \
	src/win32lib.o \
	tests/BitmapTool.o \
	tests/buffer.o \
	tests/ByteRangeMap.o \
	tests/ByteRangeSet.o \
	tests/CharacterEncoder.o \
	tests/CharacterFinder.o \
	tests/CommentsDataObject.o \
	tests/CommentTree.o \
	tests/ConsoleBuffer.o \
	tests/DiffWindow.o \
	tests/DisassemblyRegion.o \
	tests/Document.o \
	tests/DocumentCtrl.o \
	tests/endian_conv.o \
	tests/FastRectangleFiller.o \
	tests/IntelHexExport.o \
	tests/IntelHexImport.o \
	tests/LuaPluginLoader.o \
	tests/main.o \
	tests/NestedOffsetLengthMap.o \
	tests/NumericTextCtrl.o \
	tests/search-bseq.o \
	tests/search-text.o \
	tests/SearchBase.o \
	tests/SearchValue.o \
	tests/SafeWindowPointer.o \
	tests/SharedDocumentPointer.o \

=== help/Makefile ===
# Reverse Engineer's Hex Editor
# Copyright (C) 2022 Daniel Collins <solemnwarning@solemnwarning.net>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as published by
# the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

HHC ?= "C:\Program Files (x86)\HTML Help Workshop\hhc.exe"
PERL ?= perl

PAGES := \
	bitmap \
	bt \
	bt-funcs \
	bt-syntax \
	bt-types \
	comments \
	diff \
	index \
	plugins \
	types \
	virt-mapping

.PHONY: all
all:
	@echo "Usage: make rehex.htb OR rehex.chm OR online-help" 1>&2
	@false

# Don't leave empty/incomplete pages if rendering fails
.DELETE_ON_ERROR:

.PHONY: clean
clean:
	rm -rf chm/output/
	rm -rf wx/output/
	rm -rf online/output/

CHM_TARGETS := \
	$(addsuffix .html,$(addprefix chm/output/,$(PAGES))) \
	chm/output/rehex.hhc \
	chm/output/rehex.hhk

rehex.chm: $(CHM_TARGETS)
	cp content/* chm/content/* chm/output/
	# hhc.exe returns 0 on failure and 1 on success... good job Microsoft.
	# https://stackoverflow.com/a/39040033
	! $(HHC) chm/output/rehex.hhp
	cp chm/output/rehex.chm $@

chm/output/rehex.%: chm/templates/%.tt contents.txt
	@mkdir -p chm/output/ $(shell dirname .d/$@.d)
	$(PERL) template.pl --include chm/templates --dep-file .d/$@.d --dep-target $@ $* > $@

chm/output/%.html: pages/%.tt
	@mkdir -p chm/output/ $(shell dirname .d/$@.d)
	$(PERL) template.pl --include chm/templates --include pages --dep-file .d/$@.d --dep-target $@ $* > $@

WX_TARGETS := \
	$(addsuffix .html,$(addprefix wx/output/,$(PAGES))) \
	wx/output/rehex.hhc \
	wx/output/rehex.hhk

rehex.htb: $(WX_TARGETS)
	cp content/* wx/content/* wx/output/
	zip -rj rehex.htb wx/output/

wx/output/rehex.%: wx/templates/%.tt contents.txt
	@mkdir -p wx/output/ $(shell dirname .d/$@.d)
	$(PERL) template.pl --include wx/templates --dep-file .d/$@.d --dep-target $@ $* > $@

wx/output/%.html: pages/%.tt
	@mkdir -p wx/output/ $(shell dirname .d/$@.d)
	$(PERL) template.pl --include wx/templates --include pages --dep-file .d/$@.d --dep-target $@ $* > $@

ONLINE_TARGETS := \
	$(addsuffix .html,$(addprefix online/output/,$(PAGES)))

.PHONY: online-help
online-help: $(ONLINE_TARGETS)
	cp content/* online/content/* online/output/

online/output/%.html: pages/%.tt contents.txt
	@mkdir -p online/output/ $(shell dirname .d/$@.d)
	$(PERL) template.pl --include online/templates --include pages --dep-file .d/$@.d --dep-target $@ $* > $@

include $(shell test -d .d/ && find .d/ -name '*.d' -type f)

=== plugins/binary-template/Makefile ===
# Binary Template plugin for REHex
# Copyright (C) 2021-2022 Daniel Collins <solemnwarning@solemnwarning.net>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as published by
# the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

INSTALL_FILES := \
	executor.lua \
	executor/arrayvalue.lua \
	executor/filearrayvalue.lua \
	executor/filevalue.lua \
	executor/immediatevalue.lua \
	executor/plainvalue.lua \
	executor/structvalue.lua \
	parser.lua \
	plugin.lua \
	preprocessor.lua \
	lulpeg/lulpeg.lua \
	templates/riff.bt

prefix      ?= /usr/local
exec_prefix ?= $(prefix)
bindir      ?= $(exec_prefix)/bin
datarootdir ?= $(prefix)/share
libdir      ?= $(exec_prefix)/lib

LUA ?= lua

PLUGIN_NAME := binary-template
PLUGINS_INST_DIR ?= $(DESTDIR)$(libdir)/rehex

ifeq ($(BUSTED),)
	# LuaRocks under MinGW doesn't install busted under a bin/ directory - it sticks it
	# elsewhere and puts a .bat that runs it under the right Lua environment for Reasons.
	
	BUSTED := $(shell busted --version > /dev/null 2>&1 && echo busted --lua=$(LUA))
	ifeq ($(BUSTED),)
		BUSTED := $(shell busted.bat --version > /dev/null 2>&1 && echo busted.bat --lua=$(LUA))
	endif
	
	ifeq ($(BUSTED),)
		X := $(error Neither busted or busted.bat found in PATH)
	endif
endif

.PHONY: all
all:

.PHONY: check
check:
	$(BUSTED) .

.PHONY: install
install:
	for f in $(INSTALL_FILES); \
	do \
		mkdir -p $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/`dirname $${f}`; \
		install -m 0644 $${f} $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/$${f}; \
	done

.PHONY: uninstall
uninstall:
	rm -f $(addprefix $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/,$(INSTALL_FILES))
	
	rm -df $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/templates/
	rm -df $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/lulpeg/
	rm -df $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/

=== plugins/pcap/Makefile ===
# PE EXE/DLL parsing plugin for REHex
# Copyright (C) 2021 Daniel Collins <solemnwarning@solemnwarning.net>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as published by
# the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

INSTALL_FILES := \
	plugin.lua

prefix      ?= /usr/local
exec_prefix ?= $(prefix)
bindir      ?= $(exec_prefix)/bin
datarootdir ?= $(prefix)/share
libdir      ?= $(exec_prefix)/lib

PLUGIN_NAME := pcap
PLUGINS_INST_DIR ?= $(DESTDIR)$(libdir)/rehex

.PHONY: all
all:

.PHONY: check
check:

.PHONY: install
install:
	for f in $(INSTALL_FILES); \
	do \
		mkdir -p $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/`dirname $${f}`; \
		install -m 0644 $${f} $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/$${f}; \
	done

.PHONY: uninstall
uninstall:
	rm -f $(addprefix $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/,$(INSTALL_FILES))
	rm -df $(PLUGINS_INST_DIR)/$(PLUGIN_NAME)/

=== wxLua/bindings/wxlua/Makefile ===
# File:		Makefile
# Author:	John Labenski, J Winwood
# Created:	2002
# Updated:
# Copyright: (c) 2002. J Winwood

WXLUA_DIR = ../..

all: genwxbind

genwxbind:
	@(cd $(WXLUA_DIR)/bindings && ../bin/lua -e"rulesFilename=\"wxlua/wxlua_rules.lua\"" genwxbind.lua)

# do nothing to clean
clean:

=== wxLua/modules/wxlua/CMakeLists.txt ===
project( wxLua_Modules_wxLua )

wxLua_Modules_wxLua_TARGETS()

=== wxLua/modules/wxbind/src/Makefile ===
# File:		Makefile
# Author:	John Labenski, J Winwood
# Created:	2002
# Updated:
# Copyright: (c) 2002 Lomtick Software. All rights reserved.
#
# Makefile for wxLuaBinding library using gmake

# Override this on the command line to use your own wxluasetup.h
WXLUASETUP = wxluasetup.h

# ----------------------------------------------------------------------------
# Set path to root of wxLua
WXLUA_DIR = ../../..

# ----------------------------------------------------------------------------
# Include wxLua settings using wx-config for wxWidgets parameters

include $(WXLUA_DIR)/build/Makefile_wx-config.in

# ----------------------------------------------------------------------------

.cpp.o:
	$(CXX) -include $(WXLUASETUP) -c $(CXXFLAGS) $(APPEXTRADEFS) -o $@ $<

all: wxLuaBindAdvLib wxLuaBindAUILib wxLuaBindBaseLib wxLuaBindCoreLib wxLuaBindGLLib wxLuaBindHTMLLib wxLuaBindMediaLib wxLuaBindNetLib wxLuaBindSTCLib wxLuaBindXMLLib wxLuaBindXRCLib

clean: cleanlib cleanwxbind

cleanwxbind:
	@($(MAKE) -f Makefile_wxadv      clean)
	@($(MAKE) -f Makefile_wxaui      clean)
	@($(MAKE) -f Makefile_wxbase     clean)
	@($(MAKE) -f Makefile_wxcore     clean)
	@($(MAKE) -f Makefile_wxgl       clean)
	@($(MAKE) -f Makefile_wxhtml     clean)
	@($(MAKE) -f Makefile_wxmedia    clean)
	@($(MAKE) -f Makefile_wxnet      clean)
	@($(MAKE) -f Makefile_wxrichtext clean)
	@($(MAKE) -f Makefile_wxstc      clean)
	@($(MAKE) -f Makefile_wxxml      clean)
	@($(MAKE) -f Makefile_wxxrc      clean)


# ----------------------------------------------------------------------------
# Include wxLua targets using wx-config for wxWidgets parameters

include $(WXLUA_DIR)/build/Makefile_wx-config_targets.in

-include $(DEPFILES)

=== wxLua/modules/wxlua/debug/CMakeLists.txt ===
project( wxLua_Modules_wxLua_Debug )

wxLua_Modules_wxLua_Debug_TARGETS()

=== wxLua/modules/wxlua/debugger/CMakeLists.txt ===
project( wxLua_Modules_wxLua_Debugger )

wxLua_Modules_wxLua_Debugger_TARGETS()

=== wxLua/modules/wxlua/debugger/Makefile ===
# File:		Makefile
# Author:	John Labenski, J Winwood
# Created:	2002
# Updated:
# Copyright: (c) 2002 Lomtick Software. All rights reserved.
#
# Makefile for wxLua library using gmake

# ----------------------------------------------------------------------------
# Set path to root of wxLua
WXLUA_DIR = ../../..

# ----------------------------------------------------------------------------
# Include wxLua settings using wx-config for wxWidgets parameters

include $(WXLUA_DIR)/build/Makefile_wx-config.in

# ----------------------------------------------------------------------------

WXLUA_TARGET_LIBNAME = lib$(WXLUADEBUGGER_LIB)

# ----------------------------------------------------------------------------

HEADERS = \
	wxldserv.h \
	wxldtarg.h \
	wxlsock.h \
	wxluadebuggerdefs.h

SOURCES = \
	wxldserv.cpp \
	wxldtarg.cpp \
	wxlsock.cpp \
	wxluadebugger_bind.cpp

OBJECTS=$(SOURCES:.cpp=.o)
DEPFILES=$(OBJECTS:.o=.d)

# ----------------------------------------------------------------------------

.cpp.o:
	$(CXX) -c $(CXXFLAGS) $(APPEXTRADEFS) -o $@ $<

all: $(WXLUA_TARGET_LIB_STATIC) $(WXLUA_TARGET_LIB_SHARED)

clean: cleanlib

# ----------------------------------------------------------------------------
# Include wxLua targets using wx-config for wxWidgets parameters

include $(WXLUA_DIR)/build/Makefile_wx-config_targets.in

-include $(DEPFILES)

=== debian/changelog ===
rehex (0.5.4-0~ubuntu1804) bionic; urgency=low

  * Allow passing arguments to structs created via ArrayResize() and
    ArrayExtend() template functions.

  * Fix parsing of whitespace in template array dereference (#175).

  * Display offsets in comments panel (#165).

  * Don't show expand arrows next to comments without children in comments
    panel on Windows/macOS.

  * Improve performance of templates that declare many (thousands+) of
    variables in the file.

  * Add Error() function for templates (#186).

  * Fix crash when attempting to use string as a file variable in
    templates (#185).

  * [Pavel Martens] Add plugin for annotating pcap files.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 23 Oct 2022 22:52:11 +0100

rehex (0.5.3-0~ubuntu1804) bionic; urgency=low

  * Correctly nest comments when updating comments panel (#169).

  * Update text in comments panel when a comment is modified.

  * Fix display of >4GiB virtual offsets in files that are <=4GiB (#170).

  * Add support for code page 437 (IBM) and 932/936/949/950 (Microsoft).

  * Fix handling of multibyte character boundaries in document view.

  * Draw wide characters in document view (#173).

  * Move forwards/backwards and select whole instructions from disassembly
    in document view.

  * Don't capture tab key press in text area of document view.

  * Add missing error checks.

  * Add number base option to "Jump to offset" dialog.

  * Drawing optimisations (improves responsiveness), particularly on macOS.

  * Fix some undefined behaviour issues.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sat, 25 Jun 2022 17:51:36 +0100

rehex (0.5.2-0~ubuntu1804) bionic; urgency=low

  * Correctly nest comments when updating comments panel (#169).

  * Update text in comments panel when a comment is modified.

  * Fix display of >4GiB virtual offsets in files that are <=4GiB (#170).

  * Add support for code page 437 (IBM) and 932/936/949/950 (Microsoft).

  * Fix handling of multibyte character boundaries in document view.

  * Draw wide characters in document view (#173).

  * Move forwards/backwards and select whole instructions from disassembly
    in document view.

  * Don't capture tab key press in text area of document view.

  * Add missing error checks.

  * Add number base option to "Jump to offset" dialog.

  * Drawing optimisations (improves responsiveness), particularly on macOS.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Fri, 24 Jun 2022 21:53:32 +0100

rehex (0.5.0-0~ubuntu1804) bionic; urgency=low

  * Added "x86 disassembly syntax" to "View" menu to allow selecting between
    Intel or AT&T notation for x86 disassembly (#142).

  * Handle file open message used for "Open With" on macOS (#144).

  * Added --compare switch to jump straight into comparing two files (#141).

  * Fix timer leak that can cause a crash when closing the compare window or
    strings panel.

  * Add import and export functions for Intel Hex files (#102).

  * Add online help (#147).

  * Add Bitmap Data Visualisation tool (#29).

  * Add Binary Template support (#138).

  * [Emily Ellis] Save new files without the execute bit set (#154).

  * Include highlight colour names in context menu (#153).

  * Save write protect setting in rehex-meta.json (#143).

  * Fix several occasional crashes.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sat, 23 Apr 2022 15:19:07 +0100

rehex (0.4.1-0~ubuntu1804) bionic; urgency=low

  * Fixed font-dependent rendering glitches when control characters or other
    Unicode oddities were present in the text view.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Mon, 03 Jan 2022 16:55:19 +0000

rehex (0.4.0-0~ubuntu1804) bionic; urgency=low

  * Add data types for common text encodings (Unicode, ISO-8859) - text
    displayed or typed into the text view on the right will be decoded or
    encoded appropriately (#10).

  * Treat pasted text as text rather than a string of raw bytes.

  * Add 8-bit integer data types.

  * Don't mark new files as unsaved.

  * Store cursor position history and allow jumping backwards/forwards (#81).

  * Allow jumping to previous/next difference in data compare window (#131).

  * Collapse long ranges of identical data in data compare window (#85).

  * Added "Jump to offset in main window" to data compare window context menu.

  * Added shortcuts for comparing data (#103).

  * Add support for other encodings to strings tool (#106).

  * Add write protect flag to prevent accidental changes to file data during
    analysis (#130).

  * Respect system cursor blink speed setting (#112).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Mon, 20 Dec 2021 17:44:13 +0000

rehex (0.3.92-0~ubuntu1804) bionic; urgency=low

  * Reduce persistent memory usage (#52).

  * Fully undo virtual mapping changes in one step (#126).

  * Fix build dependency errors (#129).

  * Add "Find previous" button to search dialogs (#111).

  * Fix hard-to-see colours in "Decode values" panel on some systems (#127).

  * Fix build errors on FreeBSD (#133).

  * Prevent document from jumping around when the window is resized or
    disassembly is in progress (#132).

  * Fix build errors when using wxWidgets 3.1.5 and newer.

  * Refactor selection handling to make sense in virtual section view (#125).

  * Add font face setting to "View" menu (#128).

  * Correctly track whether files have been modified since saving (#122).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Tue, 24 Aug 2021 21:27:01 +0100

rehex (0.3.91-0~ubuntu1804) bionic; urgency=low

  * Fix loading of plugins bundled as part of an AppImage.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Mon, 03 May 2021 14:03:31 +0100

rehex (0.3.90-0~ubuntu1804) bionic; urgency=low

  * Show disassembly of machine code in the main document view (#94).

  * Add font size settings to "View" menu (#97).

  * Add float/double types to "Set data type" menu (#104).



=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export prefix := /usr
export LUA := lua5.3

# Snapshot builds are performed using source packages generated by git-buildpackage, which lack
# the .git/ directory. The Buildkite job does a changelog bump using the Git commit SHA, which we
# must then pull back out and stick in the environment for the Makefile.
#
# This hack is better or worse than maintaining upstream tar in the Git repo and import-orig'ing
# the result of 'make dist' before kicking off the snapshot build, depending on your point of view.

GIT_COMMIT_SHA = $(shell dpkg-parsechangelog --show-field Version | grep + | cut -d+ -f2 | cut -d- -f1)
ifneq ($(GIT_COMMIT_SHA),)
	export GIT_COMMIT_SHA
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKE_J_FLAG = -j$(NUMJOBS)
endif

%:
	dh $@

override_dh_auto_test:
	xvfb-run -a -e /dev/stdout make $(MAKE_J_FLAG) LUA=lua5.3 check

## rehex 0.60.1

=== Makefile ===
--- 
+++ 
@@ -59,8 +59,8 @@
 endif
 
 ifeq ($(need_compiler_flags),1)
-	WX_CXXFLAGS ?= $(call shell-or-die,$(WX_CONFIG) --cxxflags base core aui propgrid adv $(HELP_LIBS))
-	WX_LIBS     ?= $(call shell-or-die,$(WX_CONFIG) --libs     base core aui propgrid adv $(HELP_LIBS))
+	WX_CXXFLAGS ?= $(call shell-or-die,$(WX_CONFIG) --cxxflags base core aui propgrid adv net $(HELP_LIBS))
+	WX_LIBS     ?= $(call shell-or-die,$(WX_CONFIG) --libs     base core aui propgrid adv net $(HELP_LIBS))
 	
 	CAPSTONE_CFLAGS ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --cflags)
 	CAPSTONE_LIBS   ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --libs)
@@ -95,9 +95,9 @@
 	PROFILE_CFLAGS := -DREHEX_PROFILE
 endif
 
-CFLAGS          := -Wall -std=c99   -I. -Iinclude/ -IwxLua/modules/ -DREHEX_CACHE_CHARACTER_BITMAPS $(DEBUG_CFLAGS) $(PROFILE_CFLAGS) $(HELP_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(CFLAGS)
-CXXFLAGS_NO_GTK := -Wall -std=c++11 -I. -Iinclude/ -IwxLua/modules/ -DREHEX_CACHE_CHARACTER_BITMAPS $(DEBUG_CFLAGS) $(PROFILE_CFLAGS) $(HELP_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(CXXFLAGS)
-CXXFLAGS        := -Wall -std=c++11 -I. -Iinclude/ -IwxLua/modules/ -DREHEX_CACHE_CHARACTER_BITMAPS $(DEBUG_CFLAGS) $(PROFILE_CFLAGS) $(HELP_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(GTK_CFLAGS) $(CXXFLAGS)
+CFLAGS          := -Wall -std=c99   -I. -Iinclude/ -IwxLua/modules/ -IwxFreeChart/include/                       -DREHEX_CACHE_CHARACTER_BITMAPS $(DEBUG_CFLAGS) $(PROFILE_CFLAGS) $(HELP_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(CFLAGS)
+CXXFLAGS_NO_GTK := -Wall -std=c++11 -I. -Iinclude/ -IwxLua/modules/ -IwxFreeChart/include/ -DwxOVERRIDE=override -DREHEX_CACHE_CHARACTER_BITMAPS $(DEBUG_CFLAGS) $(PROFILE_CFLAGS) $(HELP_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(CXXFLAGS)
+CXXFLAGS        := -Wall -std=c++11 -I. -Iinclude/ -IwxLua/modules/ -IwxFreeChart/include/ -DwxOVERRIDE=override -DREHEX_CACHE_CHARACTER_BITMAPS $(DEBUG_CFLAGS) $(PROFILE_CFLAGS) $(HELP_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(GTK_CFLAGS) $(CXXFLAGS)
 
 uname_S := $(shell uname -s 2>/dev/null)
 ifeq ($(uname_S),FreeBSD)
@@ -110,7 +110,7 @@
 LDLIBS := -lunistring $(WX_LIBS) $(GTK_LIBS) $(CAPSTONE_LIBS) $(JANSSON_LIBS) $(LUA_LIBS) $(LDLIBS)
 
 # Define this for releases
-VERSION := 0.5.4
+VERSION := 0.60.1
 
 ifdef VERSION
 	LONG_VERSION := Version $(VERSION)
@@ -126,8 +126,8 @@
 	
 	GIT_COMMIT_TIME ?= $(call shell-or-die,git log -1 --format="%ct")
 	
-	VERSION      := cd847ccb965b8b6de478aaf98433f5c46bd1d27f
-	LONG_VERSION := Snapshot cd847ccb965b8b6de478aaf98433f5c46bd1d27f
+	VERSION      := 26b4af2a666e2fd13466a99dd50f4d1e70177c7c
+	LONG_VERSION := Snapshot 26b4af2a666e2fd13466a99dd50f4d1e70177c7c
 endif
 
 DEPDIR := .d
@@ -234,6 +234,67 @@
 	wxLua/modules/wxbind/src/wxcore_windows.o \
 	wxLua/modules/wxbind/src/wxcore_wxlcore.o \
 	wxLua/modules/wxbind/src/wxpropgrid_bind.o
+
+WXFREECHART_OBJS := \
+	wxFreeChart/src/areadraw.o \
+	wxFreeChart/src/art.o \
+	wxFreeChart/src/axis/axis.o \
+	wxFreeChart/src/axis/categoryaxis.o \
+	wxFreeChart/src/axis/compdateaxis.o \
+	wxFreeChart/src/axis/dateaxis.o \
+	wxFreeChart/src/axis/juliandateaxis.o \
+	wxFreeChart/src/axis/labelaxis.o \
+	wxFreeChart/src/axis/logarithmicnumberaxis.o \
+	wxFreeChart/src/axis/numberaxis.o \
+	wxFreeChart/src/axisplot.o \
+	wxFreeChart/src/bars/barplot.o \
+	wxFreeChart/src/bars/barrenderer.o \
+	wxFreeChart/src/category/categorydataset.o \
+	wxFreeChart/src/category/categoryrenderer.o \
+	wxFreeChart/src/category/categorysimpledataset.o \
+	wxFreeChart/src/chart.o \
+	wxFreeChart/src/chartpanel.o \
+	wxFreeChart/src/chartsplitpanel.o \
+	wxFreeChart/src/colorscheme.o \
+	wxFreeChart/src/crosshair.o \
+	wxFreeChart/src/dataset.o \
+	wxFreeChart/src/gantt/ganttdataset.o \
+	wxFreeChart/src/gantt/ganttplot.o \
+	wxFreeChart/src/gantt/ganttrenderer.o \
+	wxFreeChart/src/gantt/ganttsimpledataset.o \
+	wxFreeChart/src/legend.o \
+	wxFreeChart/src/marker.o \
+	wxFreeChart/src/multiplot.o \
+	wxFreeChart/src/ohlc/movingaverage.o \
+	wxFreeChart/src/ohlc/ohlcbarrenderer.o \
+	wxFreeChart/src/ohlc/ohlccandlestickrenderer.o \
+	wxFreeChart/src/ohlc/ohlcdataset.o \
+	wxFreeChart/src/ohlc/ohlcplot.o \
+	wxFreeChart/src/ohlc/ohlcrenderer.o \
+	wxFreeChart/src/ohlc/ohlcsimpledataset.o \
+	wxFreeChart/src/pie/pieplot.o \
+	wxFreeChart/src/plot.o \
+	wxFreeChart/src/renderer.o \
+	wxFreeChart/src/symbol.o \
+	wxFreeChart/src/title.o \
+	wxFreeChart/src/tooltips.o \
+	wxFreeChart/src/xy/functions/polynom.o \
+	wxFreeChart/src/xy/functions/sinefunction.o \
+	wxFreeChart/src/xy/juliantimeseriesdataset.o \
+	wxFreeChart/src/xy/timeseriesdataset.o \
+	wxFreeChart/src/xy/vectordataset.o \
+	wxFreeChart/src/xy/xyarearenderer.o \
+	wxFreeChart/src/xy/xydataset.o \
+	wxFreeChart/src/xy/xydynamicdataset.o \
+	wxFreeChart/src/xy/xyhistorenderer.o \
+	wxFreeChart/src/xy/xylinerenderer.o \
+	wxFreeChart/src/xy/xyplot.o \
+	wxFreeChart/src/xy/xyrenderer.o \
+	wxFreeChart/src/xy/xysimpledataset.o \
+	wxFreeChart/src/xyz/bubbleplot.o \
+	wxFreeChart/src/xyz/xyzdataset.o \
+	wxFreeChart/src/xyz/xyzrenderer.o \
+	wxFreeChart/src/zoompan.o
 
 APP_OBJS := \
 	res/actual_size16.o \
@@ -278,8 +339,10 @@
 	src/CommentTree.o \
 	src/ConsoleBuffer.o \
 	src/ConsolePanel.o \
+	src/DataHistogramPanel.o \
 	src/DataType.o \
 	src/decodepanel.o \
+	src/DetachableNotebook.o \
 	src/DiffWindow.o \
 	src/disassemble.o \
 	src/DisassemblyRegion.o \
@@ -290,6 +353,7 @@
 	src/FillRangeDialog.o \
 	src/IntelHexExport.o \
 	src/IntelHexImport.o \
+	src/IPC.o \
 	src/LicenseDialog.o \
 	src/lua-bindings/rehex_bind.o \
 	src/lua-plugin-preload.o \
@@ -297,114 +361,11 @@
 	src/mainwindow.o \
 	src/Palette.o \
 	src/profile.o \
+	src/RangeChoiceLinear.o \
+	src/RangeDialog.o \
+	src/RangeProcessor.o \
 	src/search.o \
-	src/SelectRangeDialog.o \
 	src/StringPanel.o \
 	src/textentrydialog.o \
 	src/Tab.o \
-	src/ToolPanel.o \
-	src/util.o \
-	src/VirtualMappingDialog.o \
-	src/VirtualMappingList.o \
-	src/win32lib.o \
-	$(WXLUA_OBJS) \
-	$(WXBIND_OBJS) \
-	$(EXTRA_APP_OBJS)
-
-$(EXE): $(APP_OBJS) $(GTKCONFIG_EXE)
-	$(CXX) $(CXXFLAGS) -DLONG_VERSION='"$(LONG_VERSION)"' -DLIBDIR='"$(libdir)"' -DDATADIR='"$(datadir)"' -c -o res/version.o res/version.cpp
-	$(CXX) $(CXXFLAGS) -o $@ $(APP_OBJS) res/version.o $(LDFLAGS) $(LDLIBS)
-
-TEST_OBJS := \
-	googletest/src/gtest-all.o \
-	res/actual_size16.o \
-	res/ascii16.o \
-	res/ascii24.o \
-	res/ascii32.o \
-	res/ascii48.o \
-	res/diff_fold16.o \
-	res/diff_fold24.o \
-	res/diff_fold32.o \
-	res/diff_fold48.o \
-	res/fit_to_screen16.o \
-	res/icon16.o \
-	res/icon32.o \
-	res/icon48.o \
-	res/icon64.o \
-	res/icon128.o \
-	res/license.o \
-	res/offsets16.o \
-	res/offsets24.o \
-	res/offsets32.o \
-	res/offsets48.o \
-	res/spinner24.o \
-	res/swap_horiz16.o \
-	res/swap_vert16.o \
-	res/zoom_in16.o \
-	res/zoom_out16.o \
-	src/AboutDialog.o \
-	src/AppSettings.o \
-	src/AppTestable.o \
-	src/ArtProvider.o \
-	src/BasicDataTypes.o \
-	src/BitmapTool.o \
-	src/buffer.o \
-	src/ByteRangeSet.o \
-	src/BytesPerLineDialog.o \
-	src/CharacterEncoder.o \
-	src/CharacterFinder.o \
-	src/ClickText.o \
-	src/CommentTree.o \
-	src/ConsoleBuffer.o \
-	src/DataType.o \
-	src/DiffWindow.o \
-	src/DisassemblyRegion.o \
-	src/document.o \
-	src/DocumentCtrl.o \
-	src/EditCommentDialog.o \
-	src/Events.o \
-	src/FillRangeDialog.o \
-	src/IntelHexExport.o \
-	src/IntelHexImport.o \
-	src/LicenseDialog.o \
-	src/lua-bindings/rehex_bind.o \
-	src/lua-plugin-preload.o \
-	src/LuaPluginLoader.o \
-	src/mainwindow.o \
-	src/Palette.o \
-	src/search.o \
-	src/SelectRangeDialog.o \
-	src/StringPanel.o \
-	src/Tab.o \
-	src/textentrydialog.o \
-	src/ToolPanel.o \
-	src/util.o \
-	src/VirtualMappingDialog.o \
-	src/win32lib.o \
-	tests/BitmapTool.o \
-	tests/buffer.o \
-	tests/ByteRangeMap.o \
-	tests/ByteRangeSet.o \
-	tests/CharacterEncoder.o \
-	tests/CharacterFinder.o \
-	tests/CommentsDataObject.o \
-	tests/CommentTree.o \
-	tests/ConsoleBuffer.o \
-	tests/DiffWindow.o \
-	tests/DisassemblyRegion.o \
-	tests/Document.o \
-	tests/DocumentCtrl.o \
-	tests/endian_conv.o \
-	tests/FastRectangleFiller.o \
-	tests/IntelHexExport.o \
-	tests/IntelHexImport.o \
-	tests/LuaPluginLoader.o \
-	tests/main.o \
-	tests/NestedOffsetLengthMap.o \
-	tests/NumericTextCtrl.o \
-	tests/search-bseq.o \
-	tests/search-text.o \
-	tests/SearchBase.o \
-	tests/SearchValue.o \
-	tests/SafeWindowPointer.o \
-	tests/SharedDocumentPointer.o \
+	src/ThreadPool.o \

=== help/Makefile ===
--- 
+++ 
@@ -21,6 +21,7 @@
 	bitmap \
 	bt \
 	bt-funcs \
+	bt-preprocessor \
 	bt-syntax \
 	bt-types \
 	comments \

=== debian/changelog ===
rehex (0.60.1-0~ubuntu2304) lunar; urgency=low

  * Install missing parts of binary template plugin.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Fri, 28 Jul 2023 20:41:32 +0100

rehex (0.60.0-0~ubuntu2304) lunar; urgency=low

  * Add data histogram tool (#140).

  * Use virtual offsets in "Select range" dialog.

  * Don't re-open files to save when there are no changes (#193).

  * Remember recently selected templates (#183).

  * Fix crash when running rehex for the first time on some systems (#194).

  * Correctly draw insert cursor over highlighted data and at the end of the
    file (#196).

  * Fix true/false not being usable inside template functions/structs (#197).

  * Expose current array index as ArrayIndex when expanding arrays of structs
    in templates (#191).

  * Implement lexical variable scoping in templates and allow functions to
    access global variables defined above them (#190).

  * Add <charset = "XXX"> syntax to templates (#184).

  * Add character set option to text search (#182, #200).

  * Add "Delete comment and children" context menu command to delete a comment
    and any comments encapsulated by it (#198).

  * Add "Apply template from cursor" option to binary template tool.

  * Fix cases where the strings tool would appear to run forever with an empty
    file.

  * Remove strings from the strings panel when they are deleted from the file.

  * Add new ReadString(), SPrintf(), SetComment(), StringLengthBytes(),
    ArrayPush(), ArrayPop() and OffsetOf() template function.

  * Fix repeated execution of the same switch() block in a template (#202).

  * Monitor for open files being externally modified and allow reloading (#124).

  * Add 'private' variables to template language.

  * Fix template format strings that expand to further format tokens.

  * Fix template error when converting a float to an int.

  * Improve performance when large numbers of comments are defined.

  * Open original file when passed a rehex-meta file on the command line (#207).

  * Add IBM codepage 866 and Windows-1251 (#208).

  * Fix crash when attempting to open a directory/bundle on macOS.
 -- Daniel Collins <solemnwarning@solemnwarning.net>  Fri, 28 Jul 2023 19:50:46 +0100

rehex (0.5.4-0~ubuntu2304) lunar; urgency=low

  * Allow passing arguments to structs created via ArrayResize() and
    ArrayExtend() template functions.

  * Fix parsing of whitespace in template array dereference (#175).

  * Display offsets in comments panel (#165).

  * Don't show expand arrows next to comments without children in comments
    panel on Windows/macOS.

  * Improve performance of templates that declare many (thousands+) of
    variables in the file.

  * Add Error() function for templates (#186).

  * Fix crash when attempting to use string as a file variable in
    templates (#185).

  * [Pavel Martens] Add plugin for annotating pcap files.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Mon, 17 Apr 2023 19:53:09 +0100

rehex (0.5.3-0~ubuntu2210) kinetic; urgency=low

  * Correctly nest comments when updating comments panel (#169).

  * Update text in comments panel when a comment is modified.

  * Fix display of >4GiB virtual offsets in files that are <=4GiB (#170).

  * Add support for code page 437 (IBM) and 932/936/949/950 (Microsoft).

  * Fix handling of multibyte character boundaries in document view.

  * Draw wide characters in document view (#173).

  * Move forwards/backwards and select whole instructions from disassembly
    in document view.

  * Don't capture tab key press in text area of document view.

  * Add missing error checks.

  * Add number base option to "Jump to offset" dialog.

  * Drawing optimisations (improves responsiveness), particularly on macOS.

  * Fix some undefined behaviour issues.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 16 Oct 2022 00:22:23 +0100

rehex (0.5.2-0~ubuntu2204) jammy; urgency=low

  * Correctly nest comments when updating comments panel (#169).

  * Update text in comments panel when a comment is modified.

  * Fix display of >4GiB virtual offsets in files that are <=4GiB (#170).

  * Add support for code page 437 (IBM) and 932/936/949/950 (Microsoft).

  * Fix handling of multibyte character boundaries in document view.

  * Draw wide characters in document view (#173).

  * Move forwards/backwards and select whole instructions from disassembly
    in document view.

  * Don't capture tab key press in text area of document view.

  * Add missing error checks.

  * Add number base option to "Jump to offset" dialog.

  * Drawing optimisations (improves responsiveness), particularly on macOS.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Fri, 24 Jun 2022 21:53:33 +0100

rehex (0.5.0-0~ubuntu2204) jammy; urgency=low

  * Added "x86 disassembly syntax" to "View" menu to allow selecting between
    Intel or AT&T notation for x86 disassembly (#142).

  * Handle file open message used for "Open With" on macOS (#144).

  * Added --compare switch to jump straight into comparing two files (#141).

  * Fix timer leak that can cause a crash when closing the compare window or
    strings panel.

  * Add import and export functions for Intel Hex files (#102).

  * Add online help (#147).

  * Add Bitmap Data Visualisation tool (#29).

  * Add Binary Template support (#138).

  * [Emily Ellis] Save new files without the execute bit set (#154).

  * Include highlight colour names in context menu (#153).

  * Save write protect setting in rehex-meta.json (#143).

  * Fix several occasional crashes.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sat, 23 Apr 2022 15:19:08 +0100

rehex (0.4.1-0~ubuntu2204) jammy; urgency=low

  * Release to jammy.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Mon, 04 Apr 2022 12:56:36 +0100

=== debian/control ===
Source: rehex
Priority: extra
Maintainer: Daniel Collins <solemnwarning@solemnwarning.net>
Build-Depends:
 libcapstone-dev,
 debhelper (>= 9),
 libgtk-3-dev,
 libjansson-dev,
 libwxgtk3.2-dev,
 liblua5.3-dev,
 libtemplate-perl,
 libunistring-dev,
 lua-busted,
 lua5.3,
 pkg-config,
 xauth,
 xvfb,
 wx3.2-headers,
 zip,
 zlib1g-dev
Standards-Version: 3.9.4
Section: editors
Homepage: https://github.com/solemnwarning/rehex/

Package: rehex
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcapstone4,
 libjansson4,
 liblua5.3-0,
 libunistring2,
 libwxgtk3.2-1,
 zlib1g
Description: Reverse Engineers' Hex Editor

## rehex 0.61.1

=== debian/changelog ===
rehex (0.61.1-0~ubuntu2310) mantic; urgency=low

  * Compare data from correct file offsets when "Collapse matches" option is
    enabled in compare window (#224).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Wed, 13 Mar 2024 18:13:45 +0000

rehex (0.61.0-0~ubuntu2310) mantic; urgency=low

  * Permit trailing commas in template enum definitions (#216).

  * Add overwrite/insert toggle to "Fill range" dialog (#213).

  * Add copy/export context menu commands to strings tool (#210).

  * Fix temporary hang in strings tool when processing large files (#217).

  * Fix settings not being saved during application exit.

  * Batch comments panel updates to improve responsiveness (#205).

  * Add search field to comments panel (#204).

  * Add bit editor tool.

  * Add checksum tool (#219).

  * Add options to search for floating point values.

  * Don't reload files modified externally when requested not to.

  * Start search when Enter is pressed in search dialog input field, or search
    backwards when Shift+Enter is pressed.

  * Add "Reload automatically" toggle to "File" menu to automatically reload
    the file when modified externally (and not in the editor) (#222).

  * Preserve scroll position when reloading file.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Wed, 14 Feb 2024 21:27:51 +0000

rehex (0.60.1-0~ubuntu2310) mantic; urgency=low

  * Install missing parts of binary template plugin.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sat, 11 Nov 2023 16:03:19 +0000

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Priority: extra
 Maintainer: Daniel Collins <solemnwarning@solemnwarning.net>
 Build-Depends:
+ debhelper (>= 9),
+ libbotan-2-dev,
  libcapstone-dev,
- debhelper (>= 9),
  libgtk-3-dev,
  libjansson-dev,
  libwxgtk3.2-dev,
@@ -27,6 +28,7 @@
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
+ libbotan-2-19,
  libcapstone4,
  libjansson4,
  liblua5.3-0,
